using System;
using System.Collections;

using KnownObjects;
using Belikov.GenuineChannels;
using Belikov.GenuineChannels.Security;

namespace Client
{
	/// <summary>
	/// MessageReceiver.
	/// </summary>
	public class MessageReceiver : MarshalByRefObject, IExchangeEventReceiver
	{
		/// <summary>
		/// An operation.
		/// </summary>
		/// <param name="aString">A parameter.</param>
		/// <returns>Null.</returns>
		public object ReceiveEvent(string aString)
		{
			Console.WriteLine("Message \"{0}\" received from the server ({1}).", aString, GenuineUtility.CurrentRemoteHost.PhysicalAddress.ToString());
			return null;
		}

		/// <summary>
		/// This is to insure that when created as a Singleton, the first instance never dies,
		/// regardless of the expired time.
		/// </summary>
		/// <returns></returns>
		public override object InitializeLifetimeService()
		{
			return null;
		}
	}
}
