using System;

namespace KnownObjects
{
	/// <summary>
	/// Necessary operations for subscribing clients to an event.
	/// </summary>
	public interface IExchangeEventProvider
	{
		/// <summary>
		/// Subscribes to an event.
		/// </summary>
		void Subscribe(IExchangeEventReceiver iExchangeEventReceiver);

		/// <summary>
		/// Returns a marshal-by-ref object.
		/// </summary>
		MarshalByRefObject GetAnyMbr();
	}

	/// <summary>
	/// Client's callback interface.
	/// </summary>
	public interface IExchangeEventReceiver
	{
		/// <summary>
		/// An operation.
		/// </summary>
		/// <param name="aString">A parameter.</param>
		/// <returns>Null.</returns>
		object ReceiveEvent(string aString);
	}

	public interface IExchangeKeyProvider
	{
		/// <summary>
		/// Returns a key for using in symmetric encryption algorithms.
		/// </summary>
		byte[] GetKey();
	}
}
